;Thanks to Ahmed El-Helw for the random routine used to make the dice random,
;becuase if the dice wern't randomized, this program would not be very
;useful

#include "asm86.h"              ;all the include files
#include "ti86asm.inc"
#include "ti86math.inc"
#include "ti86ops.inc"
#include "ti86abs.inc"

_setxxop2               equ     4617h   ;these are for the random routine
_convop1                equ     5577h
_fpmult                 equ     548Ch

.org _asm_exec_ram

start:
    call    _clrLCD                     ;clear screen
    call    _runindicoff                ;run indicator off
    ld      hl,52*256+18                ;loads coordinates into hl
    ld      (_penCol),hl                ;loads hl into _penCol
    ld      hl,intro                    ;loads intro in hl
    call    _vputs                      ;displays hl (intro)
    ld      b,0                         ;
    ld      c,63                        ;loads coorinates for the line
    ld      d,50                        ;
    ld      e,63                        ;
    ld      h,1                         ;loads 1 into h which tells _ILine to make the line black
    call    _ILine                      ;displays line
    ld      b,0                         ;
    ld      c,25                        ;these are all the same thing, they are
    ld      d,50                        ;drawing the 2 dice line by line
    ld      e,25
    ld      h,1
    call    _ILine
    ld      b,0
    ld      c,25
    ld      d,0
    ld      e,63
    ld      h,1
    call    _ILine
    ld      b,50
    ld      c,25
    ld      d,50
    ld      e,63
    ld      h,1
    call    _ILine
    ld      b,76
    ld      c,63
    ld      d,126
    ld      e,63
    ld      h,1
    call    _ILine
    ld      b,76
    ld      c,25
    ld      d,126
    ld      e,25
    ld      h,1
    call    _ILine
    ld      b,76
    ld      c,25
    ld      d,76
    ld      e,63
    ld      h,1
    call    _ILine
    ld      b,126
    ld      c,26
    ld      d,126
    ld      e,62
    ld      h,1
    call    _ILine

loop3:
    call    Random                      ;calls the random routine which generates a number between 1-6 for dice 1
    cp      1                           ;is the number 1?
    jp      z,none                      ;then goto "none"
    cp      2                           ;is the number 2?
    jp      z,ntwo                      ;then goto "ntwo"
    cp      3                           ;is the number 3?
    jp      z,nthree                    ;then goto "nthree"
    cp      4                           ;etc
    jp      z,nfour                     ;
    cp      5                           ;
    jp      z,nfive                     ;
    cp      6                           ;
    jp      z,nsix                      ;
    jp      nz,loop3                    ;if for some reason its not 1-6, go back to "random" which will make a new number 

random2:
    call    Random                      ;calls the random routine which generates a number between 1-6 for dice 2
    cp      1                           ;is the number 1?
    jp      z,gone                      ;then goto "gone"
    cp      2                           ;is the number 2?
    jp      z,gtwo                      ;then goto "gtwo"
    cp      3                           ;is the number 3?
    jp      z,gthree                    ;then goto "gthree"
    cp      4                           ;etc
    jp      z,gfour                     ;
    cp      5
    jp      z,gfive
    cp      6
    jp      z,gsix
    jp      nz,random2                  ;if for some reason its not 1-6, go back to "random2" which will make a new number 

choice1:                                ;this is for the "Again Exit" prompt, this is the again part.
    set     textInverse,(iy+textflags)  ;sets the text to inverse (text is white, background for it is black)
    ld      hl,58*256+45                ;loads coordinates for the text into hl
    ld      (_penCol),hl                ;loads hl into _penCol
    ld      hl,option1                  ;loads option1 into
    call    _vputs                      ;displays hl ("Again")
    res     textInverse,(iy+textflags)  ;turns the inverse text off
    ld      hl,58*256+67                ;loads coordinates for the text into hl
    ld      (_penCol),hl                ;loads hl into _penCol
    ld      hl,option2                  ;loads option2 into hl
    call    _vputs                      ;displays hl ("Exit")
    call    _getkey                     ;gets a keypress
    cp      kRight                      ;is the keypress the right arrow?
    jp      z,choice2                   ;then goto choice2
    cp      kEnter                      ;was the keypress enter?
    jp      z,start                     ;then jump up to start
    jp      nz,choice1                  ;loops back up to choice1

choice2:                                ;the "Exit" part of the "Again Exit" prompt
    ld      hl,58*256+45                ;loads coorinates for the text into hl
    ld      (_penCol),hl                ;loads hl into _penCol
    ld      hl,option1                  ;loads option1 into hl
    call    _vputs                      ;displays hl ("Again")
    ld      hl,58*256+67                ;loads coorinates for the text into hl
    ld      (_penCol),hl                ;loads hl into _penCol
    ld      hl,option2                  ;loads option2 into hl
    set     textInverse,(iy+textflags)  ;turns the text inverse on
    call    _vputs                      ;displays hl ("Exit")
    res     textInverse,(iy+textflags)  ;turns the text inverse back to off
    call    _getkey                     ;gets a keypress
    cp      kLeft                       ;was the keypress left?
    jp      z,choice1                   ;then goto choice1
    cp      kEnter                      ;was the keypress enter?
    jp      z,exit                      ;then goto exit
    jp      nz,choice2                  ;loops back to choice2


exit:
   call     _clrLCD                     ;clears the screen
   ret                                  ;exits the program
     


Random:                                 ;Ahmed El-Helw's random routine
    call    _RANDOM
    ld      a,7                         ;I'm not sure how it works :)
    call    _setxxop2
    call    _fpmult
    call    _convop1
    ld      a,e
    ret

none:                                   ;this displays one under dice 1 and will put the holes in the box for dice 1
    ld      hl,45*256+0                 ;loads the coordinates for text into hl
    ld      (_penCol),hl                ;loads hl into _penCol
    ld      hl,diceone                  ;loads diceone into hl
    call    _vputs                      ;displays hl ("One")
    ld      hl,17*256+23                ;loads coorinates for text into hl
    ld      (_penCol),hl                ;loads hl into _penCol
    ld      hl,d1                       ;loads d1 into hl
    call    _vputs                      ;displays hl (a "o" which is the dot in the dice)
    jp     random2                      ;jumps up to random2 which will generate the random number for dice number 2

ntwo:                                   ;this displays two under dice 1 and will put the holes in the box for dice 1
    ld      hl,45*256+0
    ld      (_penCol),hl
    ld      hl,dicetwo                  ;same as "none" except puts more "o"'s and displays 2
    call    _vputs
    ld      hl,16*256+14
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    jp     random2


nthree:                                 ;this displays three under dice 1 and will put the holes in the box for dice 1
    ld      hl,45*256+0
    ld      (_penCol),hl
    ld      hl,dice3                    ;same as "none" except puts more "o"'s and displays 3
    call    _vputs
    ld      hl,11*256+35
    ld      (_penCol),hl
    ld      hl,d1
    call    _vputs
    ld      hl,17*256+23
    ld      (_penCol),hl
    ld      hl,d1
    call    _vputs
    ld      hl,23*256+11
    ld      (_penCol),hl
    ld      hl,d1
    call    _vputs
    jp     random2

nfour:                                  ;this displays four under dice 1 and will put the holes in the box for dice 1
    ld      hl,45*256+0
    ld      (_penCol),hl
    ld      hl,dice4                    ;same as "none" except puts more "o"'s and displays 4
    call    _vputs
    ld      hl,9*256+13
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    ld      hl,23*256+13
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    jp     random2

nfive:                                  ;this displays five under dice 1 and will put the holes in the box for dice 1
    ld      hl,45*256+0
    ld      (_penCol),hl
    ld      hl,dice5                    ;same as "none" except puts more "o"'s and displays 5
    call    _vputs
    ld      hl,9*256+13
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    ld      hl,16*256+24
    ld      (_penCol),hl
    ld      hl,d1
    call    _vputs
    ld      hl,23*256+13
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    jp     random2

nsix:                                   ;this displays six under dice 1 and will put the holes in the box for dice 1
    ld      hl,45*256+0
    ld      (_penCol),hl
    ld      hl,dice6                    ;same as "none" except puts more "o"'s and displays 6
    call    _vputs
    ld      hl,9*256+13
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    ld      hl,16*256+13
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    ld      hl,23*256+13
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    jp     random2



gone:
    ld      hl,45*256+114               ;gone,gtwo,gthree,gfour,gfive,gsix
    ld      (_penCol),hl                ;are the same as the none,ntwo,etc
    ld      hl,diceone                  ;they just display the stuff over
    call    _vputs                      ;in dice number 2
    ld      hl,17*256+100
    ld      (_penCol),hl
    ld      hl,d1
    call    _vputs
    jp      choice1

gtwo:
    ld      hl,45*256+114
    ld      (_penCol),hl
    ld      hl,dicetwo
    call    _vputs
    ld      hl,16*256+90
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    jp     choice1


gthree:
    ld      hl,45*256+107
    ld      (_penCol),hl
    ld      hl,dice3
    call    _vputs
    ld      hl,11*256+111
    ld      (_penCol),hl
    ld      hl,d1
    call    _vputs
    ld      hl,17*256+99
    ld      (_penCol),hl
    ld      hl,d1
    call    _vputs
    ld      hl,23*256+87
    ld      (_penCol),hl
    ld      hl,d1
    call    _vputs
    jp      choice1

gfour:
    ld      hl,45*256+111
    ld      (_penCol),hl
    ld      hl,dice4
    call    _vputs
    ld      hl,9*256+89
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    ld      hl,23*256+89
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    jp      choice1

gfive:
    ld      hl,45*256+111
    ld      (_penCol),hl
    ld      hl,dice5
    call    _vputs
    ld      hl,9*256+89
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    ld      hl,16*256+100
    ld      (_penCol),hl
    ld      hl,d1
    call    _vputs
    ld      hl,23*256+89
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    jp      choice1

gsix:
    ld      hl,45*256+114
    ld      (_penCol),hl
    ld      hl,dice6
    call    _vputs
    ld      hl,9*256+89
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    ld      hl,16*256+89
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    ld      hl,23*256+89
    ld      (_penCol),hl
    ld      hl,d2
    call    _vputs
    jp      choice1

                                        ;these are all the strings

intro:
        .db    "Dice Roller v1.0"
intro2:
        .db    "by Brian Smith",0
diceone:
        .db    "one",0
dicetwo:
        .db    "two",0
dice3:
        .db    "three",0
dice4:
        .db    "four",0
dice5:
        .db    "five",0
dice6:
        .db    "six",0
option1:
        .db    "Again",0
option2:
        .db    "Exit",0
d1:
        .db    "o",0                    ;the hole for the dice
d2:
        .db    "o                 o",0  ;2 holes for number 2,4,5,6 so you don't have to draw 2 seperate "o"'s for them
.end
